<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

Include("config/global.inc.php");
checkPermissions(1, $SESSION_TIMEOUT); // if not logged in, or session has timed out...

/* these are numbers...*/
$LARGE = validateNumber('',   $_FORM['large'],    1, 1000000, FALSE);
$ProjectID = validateNumber($LA['gr-projectid'],   $_FORM['txt_project'],    1, 1000000, TRUE);
$ProjectName = "-unknown-";
$data0 = array(); /* for CREATED */
$data1 = array(); /* for CLOSED */
$data2 = array(); /* NUM-OPEN */
$labels= array(); /* for the labels(dates) */
$created_count=0;
$closed_count=0;

$strSQL = "SELECT P.project_name";
$strSQL.=" FROM $TABLE_PROJECTS AS P";
$strSQL.=" WHERE P.project_id='$ProjectID'";
//echo "Q:<DIR>$strSQL</DIR>";
$result= dbquery($strSQL);
if($row= mysql_fetch_array($result))
{
  $ProjectName=$row['project_name'];
}



$strSQL = "SELECT S.initial, S.final, E.ticket_id, T.trans_date";
$strSQL.=" FROM $TABLE_TRANSACTIONS AS T";
$strSQL.=" LEFT JOIN $TABLE_EACH_TICKET AS E ON E.ticket_id=T.ticket_id";
$strSQL.=" LEFT JOIN $TABLE_STATES AS S ON S.state_id=E.state_id";
$strSQL.=" WHERE T.type='STATE' AND E.project_id='$ProjectID'";
$strSQL.=" ORDER BY T.trans_date ASC";
//echo "Q:<DIR>$strSQL</DIR>";
$result= dbquery($strSQL);
$last_DATE=0;
$i=0;
$ticF=array();
$ticI=array();
while($row= mysql_fetch_array($result))
{
  $strDate= $row['trans_date'];
  $DATE=date("n/d/y",$strDate);
  $strTic= $row['ticket_id'];
  $strF= $row['final'];
  $strI= $row['initial'];
  //echo "$i: $strTic ($strI|$strF) $DATE<BR>\n";
  if($DATE<>$last_DATE)
  {
    $i++;
    $last_DATE=$DATE;
    $labels[$i]=$DATE;
  }
  if($row['initial'])
  {
    if(!isset($ticI[$strTic]))
    {
      $ticI[$strTic]=1;
      $created_count++;
    }
  }
  else if($row['final'])
  {
    if(!isset($ticF[$strTic]))
    {
      $ticF[$strTic]=1;
      $closed_count++;
    }
    if(!isset($ticI[$strTic])) /* this to fix errors?? */
    {
      $ticI[$strTic]=1;
      $created_count++;
    }
  }
  $data0[$i]=$created_count;
  $data1[$i]=$closed_count;
  $data2[$i]=$data0[$i]-$data1[$i];
}
//exit;


##################################
##################################
##################################
##################################
##################################
##################################
##################################

require_once("/home/usergreyguru/public_html/ChartDirector/lib/phpchartdir.php");


if($LARGE)
{
$showLabels=$i/7;
$chartW=600;
$chartH=300;
$plotW=520;
$plotH=195;
$topX=55;
$topY=58;
$title=$LA['gr-tickets-open'].": ".$LA['gr-project']." $ProjectName";
$size=15;
}
else /* small */
{
$showLabels=$i/3;
$chartW=200;
$chartH=150;
$plotW=150;
$plotH=95;
$topX=30;
$topY=30;
$title=$LA['gr-tickets-open'];
$size=8;
}


# Create an XYChart object of size 600 x 300 pixels, with a light blue (EEEEFF)
# background, black border, 1 pxiel 3D border effect and rounded corners
$c = new XYChart($chartW, $chartH, 0xeeeeff, 0x000000, 1);
$c->setRoundedFrame();

# Set the plotarea at (55, 58) and of size 520 x 195 pixels, with white background.
# Turn on both horizontal and vertical grid lines with light grey color (0xcccccc)
$c->setPlotArea($topX, $topY, $plotW, $plotH, 0xffffff, -1, -1, 0xcccccc, 0xcccccc);

if($LARGE)
{
# Add a legend box at (50, 30) (top of the chart) with horizontal layout. Use 9 pts
# Arial Bold font. Set the background and border color to Transparent.
$legendObj = $c->addLegend(50, 30, false, "arialbd.ttf", 9);
$legendObj->setBackground(Transparent);
}

# Add a title box to the chart using 15 pts Times Bold Italic font, on a light blue
# (CCCCFF) background with glass effect. white (0xffffff) on a dark red (0x800000)
# background, with a 1 pixel 3D border.
$textBoxObj = $c->addTitle($title, "timesbi.ttf", $size);
$textBoxObj->setBackground(0xccccff, 0x000000, glassEffect());

if($LARGE)
{
# Add a title to the y axis
$c->yAxis->setTitle($LA['gr-num-tics']);
}

# Set the labels on the x axis.
$c->xAxis->setLabels($labels);

# Display 1 out of 3 labels on the x-axis.
$c->xAxis->setLabelStep($showLabels);

if($LARGE)
{
# Add a title to the x axis
$c->xAxis->setTitle($LA['gr-date']);
}

# Add a line layer to the chart
$layer = $c->addLineLayer2();

# Set the default line width to 2 pixels
$layer->setLineWidth(2);

# Add the three data sets to the line layer. For demo purpose, we use a dash line
# color for the last line
$layer->addDataSet($data2, 0xff0000, $LA['gr-open']);

# output the chart
header("Content-type: image/png");
print($c->makeChart2(PNG));
?>
